/* (C) 2022 YiRing, Inc. */
package com.yiring.app.domain.key;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.yiring.auth.domain.user.User;
import com.yiring.common.domain.BasicEntity;
import java.io.Serial;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.HashSet;
import java.util.Set;
import javax.persistence.*;
import lombok.*;
import lombok.experimental.FieldDefaults;
import lombok.experimental.FieldNameConstants;
import org.hibernate.annotations.Comment;
import org.locationtech.jts.geom.Point;

/**
 *
 *
 * @author LJ-2204
 * @date 2022/5/6
 */

@Getter
@Setter
@ToString
@Builder
@NoArgsConstructor
@AllArgsConstructor
@FieldNameConstants
@FieldDefaults(level = AccessLevel.PRIVATE)
@Entity
@Table(name = "BS_KEY_ALARM")
@Comment("按键报警")
public class KeyAlarm extends BasicEntity implements Serializable {

    @Serial
    private static final long serialVersionUID = -6050505164664867107L;

    @Comment("地图 ID")
    Long areaId;

    @ManyToOne
    @JoinColumn(name = "leader_id")
    @JsonIgnore
    @Comment("负责人")
    User leader;

    @Comment("标签编号")
    String code;

    @Comment("x")
    BigDecimal x;

    @Comment("y")
    BigDecimal y;

    @Comment("z")
    BigDecimal z;

    @Comment("坐标点信息")
    Point point;

    @Comment("报警状态")
    Boolean enable;

    @Builder.Default
    @OneToMany(mappedBy = "keyAlarm")
    @Comment("推送消息记录")
    Set<KeyAlarmLog> rules = new HashSet<>(0);
}
